' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' C_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2010/10/29 
'
' FV-GP440 Continue Grab Sample Program
' -----------------------------------------------------------------
Public Class Form_FV_GP440_CONTGRABSAMPLE

    Private m_Images As List(Of FVIL.Data.CFviImage) = New List(Of FVIL.Data.CFviImage) 'A荞ݗp摜i[̈
    Private m_video As FVIL.Video.CFviVideoGP440 = New FVIL.Video.CFviVideoGP440        'rfIFV-GP440NX
    Private m_timer As FVIL.CFviTimeCounter = New FVIL.CFviTimeCounter()                'ԌvNX

    Dim intErr As Integer                                                               'G[ԍi[ϐ
    Public m_strIniFilePath As String                                                   'init@CitpXj

    Dim m_intBufImgIndex As Integer                                                     '摜IuWFNgԍ

    Private m_flgVideoOpened As Boolean                                                 'rfIfoCX̃I[v
    Private m_flgFreerun As Boolean                                                     't[̏

    Private Sub FormMainLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'FVIL̏
        'AvP[VNA ̊֐ĂяoăCuĂB 
        '̎ACZX̔F؂s܂BpԒłĂȀ͕KsKvL܂B 
        'sȂꍇ́AveNgꂽNX̎sł܂B
        FVIL._SetUp.InitVisionLibrary()

        'ԕϐ̏
        m_flgVideoOpened = False
        m_flgFreerun = False

        'vԃeLXg{bNX
        TextBoxTime.Text = "0.000"
        't[eLXg{bNX
        TextBoxFrame.Text = "0"
        'Lv`[eLXg{bNX
        TextBoxCaptureNumber.Text = "10"
        '\摜ԍ
        TextBoxBufImgIndex.Text = "0"

        'gK[hR{{bNX
        ComboBoxTrigger.Items.Clear()
        ComboBoxTrigger.Items.Add("m[}")
        ComboBoxTrigger.Items.Add("gK")
        ComboBoxTrigger.Items.Add("OgK")
        ComboBoxTrigger.SelectedIndex = 0

        'Ql@\R{{bNX
        ComboBoxBinarize.Items.Clear()
        ComboBoxBinarize.Items.Add("OC")
        ComboBoxBinarize.Items.Add("l")
        ComboBoxBinarize.SelectedIndex = 0

    End Sub

    ''' <summary>
    ''' tH[\Jn Cxgnh
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' gpmF܂B
    ''' </remarks>
    Private Sub formMain_Shown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Shown
        'gp̊mF
        Dim licence_dialog As New dialogLicence
        If (licence_dialog.ShowDialog(Me) <> Windows.Forms.DialogResult.OK) Then
            Me.Close() 'gpȂꍇ̓TvvO̓I
            Exit Sub
        End If

        'init@CI
        fnSetIniFile()

    End Sub

    ''' <summary>
    ''' I
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AvP[VIB
    ''' </remarks>
    Private Sub FormMainFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        Try
            'bNꂽ܂B 
            If (m_video.ContinuousGrab.IsMemoryLocked) Then
                '荞݂̒~
                m_video.ContinuousGrab.StopCapture()
                '摜bN̉
                m_video.ContinuousGrab.MemoryUnlock()
            End If
            'rfIfoCXI[vĂꍇ̓N[Y
            If (m_flgVideoOpened = True) Then
                m_video.Close()
                m_flgVideoOpened = False
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' init@CI֐
    ''' </summary>
    ''' <remarks>
    ''' init@C̑I܂B
    ''' </remarks>
    Private Sub fnSetIniFile()

        Dim formbroseini As New Form_BROWSEINI  'init@Cݒ

        If (Form_BROWSEINI.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            m_strIniFilePath = Form_BROWSEINI.strIniFilePath
        Else
            'init@CȈꍇ̓TvvO̓I
            Me.Close()
            Exit Sub
        End If

        Try
            'rfIfoCXI[vĂꍇ̓N[Y
            If (m_video.IsOpen = True) Then
                m_video.Close()
                m_flgVideoOpened = False
            End If

            'foCXI[v
            m_video.Open(-1, Form_BROWSEINI.SelectChannelNo)
            m_flgVideoOpened = True

            'VideoConfFile̕ύXAOpenDevicesƁAgK[[h̕ύX܂
            'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
            '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
            'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
            Threading.Thread.Sleep(350)

            'init@CR|[lgɐݒ
            If (m_strIniFilePath.Length > 0) Then
                m_video.LoadIniFile(m_strIniFilePath)
            End If

            'l\
            'gK[h擾
            ComboBoxTrigger.SelectedIndex = m_video.Trigger
            NumericUpDownExposure.Value = m_video.ExposureTime

        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Grab One{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' J荞݁B
    ''' </remarks>
    Private Sub ButtonGrabOne_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabOne.Click

        Dim msec As Double

        Try
            't[eLXg{bNX
            TextBoxFrame.Text = "0"
            '摜i[̈NA
            m_Images.Clear()
            '摜mېi[̈ǉ
            m_Images.Add(New FVIL.Data.CFviImage())
            '捞摜𐳋K
            m_video.ChangeImageSize(m_Images(0))
            '摜i[̈Zbg
            m_video.ContinuousGrab.Images = m_Images
            '摜bN
            m_video.ContinuousGrab.MemoryLock(1)

            'ԑJn
            m_timer.Start()
            'J荞
            m_video.ContinuousGrab.GrabSync(1)
            'ԑI
            msec = m_timer.Stop()
            '莞ԕ\
            TextBoxTime.Text = msec.ToString("0.000")
            '`imagẽZbg
            CFviImageView1.Image = m_Images(m_video.ContinuousGrab.QueryCaptureNo.LastFrameNo)
            'ĕ`
            CFviImageView1.Refresh()
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try

    End Sub

    ''' <summary>
    ''' Grab Continue{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' AJ荞݊JnE~B
    ''' </remarks>
    Private Sub ButtonGrabContinue_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonGrabContinue.Click

        '{^\ύX
        If (m_flgFreerun = True) Then
            't[~
            fnStopFreerun()
        Else
            Try
                'Xe[^XύX
                ButtonGrabContinue.Text = "Stop"
                ButtonGrabOne.Enabled = False
                ComboBoxBinarize.Enabled = False
                NumericUpDownLockImgNum.Enabled = False
                ComboBoxTrigger.Enabled = False
                m_flgFreerun = True
                '莞ԕ\
                TextBoxTime.Text = "0.000"
                TextBoxTime.Enabled = False
                '摜i[̈NA
                m_Images.Clear()
                For LockNum As Integer = 0 To NumericUpDownLockImgNum.Value
                    '摜mېi[̈ǉ
                    m_Images.Add(New FVIL.Data.CFviImage())
                    '捞摜𐳋K
                    m_video.ChangeImageSize(m_Images(LockNum))
                Next
                '摜i[̈Zbg
                m_video.ContinuousGrab.Images = m_Images
                '摜bN
                m_video.ContinuousGrab.MemoryLock(NumericUpDownLockImgNum.Value)
                Timer1.Interval = 50
                Timer1.Start()
                'AJ荞
                m_video.ContinuousGrab.GrabASync(TextBoxCaptureNumber.Text)
            Catch ex As Exception
                't[~
                fnStopFreerun()

                'G[
                intErr = m_video.ErrorCode
                MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End Try
        End If
        Application.DoEvents()
    End Sub

    ''' <summary>
    ''' ^C}[Cxg
    ''' </summary>
    ''' <remarks>
    ''' ^C}[ɂ\XVB
    ''' </remarks>
    Private Sub Timer1Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Try
            If (m_flgFreerun = True) Then
                If ((TextBoxCaptureNumber.Text > m_video.ContinuousGrab.QueryCaptureNo.TotalFrameCount) Or (TextBoxCaptureNumber.Text = 0)) Then
                    Timer1.Stop()
                    't[\XV
                    TextBoxFrame.Text = m_video.ContinuousGrab.QueryCaptureNo.TotalFrameCount
                    'ŐVt[Zbg
                    CFviImageView1.Image = m_Images(m_video.ContinuousGrab.QueryCaptureNo.LastFrameNo)
                    'ĕ`
                    CFviImageView1.Refresh()
                    Dim stat As Integer
                    stat = m_video.ContinuousGrab.GrabStatus
                    Timer1.Start()
                    'ԑJn
                    m_timer.Start()
                Else
                    Timer1.Stop()
                    't[\XV
                    TextBoxFrame.Text = m_video.ContinuousGrab.QueryCaptureNo.TotalFrameCount
                    'ŐVt[Zbg
                    CFviImageView1.Image = m_Images(m_video.ContinuousGrab.QueryCaptureNo.LastFrameNo)
                    'ĕ`
                    CFviImageView1.Refresh()
                    't[~
                    fnStopFreerun()
                End If
            End If
        Catch ex As Exception
            't[~
            fnStopFreerun()

            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' t[~֐
    ''' </summary>
    ''' <remarks>
    ''' t[~ƊeXe[^XύXB
    ''' </remarks>
    Private Sub fnStopFreerun()
        Try
            'Xe[^XύX
            ButtonGrabContinue.Text = "Grab Continue"
            ButtonGrabOne.Enabled = True
            ComboBoxBinarize.Enabled = True
            NumericUpDownLockImgNum.Enabled = True
            ComboBoxTrigger.Enabled = True
            m_flgFreerun = False
            Timer1.Stop()
            Timer1.Enabled = False
            '摜荞݂̒~()
            m_video.ContinuousGrab.StopCapture()
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜̔ԍ߂B
    ''' </remarks>
    Private Sub ButtonLeft_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLeft.Click
        Dim size As Integer

        m_intBufImgIndex = TextBoxBufImgIndex.Text - 1
        size = NumericUpDownLockImgNum.Value
        If (m_intBufImgIndex < 0) Then
            m_intBufImgIndex = size - 1
        End If
        If (m_intBufImgIndex < 0) Then
            m_intBufImgIndex = 0
        End If

        TextBoxBufImgIndex.Text = m_intBufImgIndex.ToString
        If (m_Images.Count > 0) Then
            '\摜Zbg
            CFviImageView1.Image = m_Images(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageView1.Refresh()
        End If
    End Sub

    ''' <summary>
    ''' {^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜̔ԍi߂B
    ''' </remarks>
    Private Sub ButtonRight_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonRight.Click
        Dim size As Integer

        m_intBufImgIndex = TextBoxBufImgIndex.Text + 1
        size = NumericUpDownLockImgNum.Value
        If (m_intBufImgIndex >= size) Then
            m_intBufImgIndex = 0
        End If

        TextBoxBufImgIndex.Text = m_intBufImgIndex.ToString
        If (m_Images.Count > 0) Then
            '\摜Zbg
            CFviImageView1.Image = m_Images(TextBoxBufImgIndex.Text)
            'ĕ`
            CFviImageView1.Refresh()
        End If
    End Sub

    ''' <summary>
    ''' Binarize ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' OC摜El摜͉̓摜IB
    ''' </remarks>
    Private Sub ComboBoxBinarize_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxBinarize.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                'CFviVideoBinarize\̂̃CX^X̃oʂɕύX鎖͏oȂׁAȉ̗lɂĐݒB
                Dim bin As FVIL.Video.CFviVideoBinarize = m_video.Binarize
                bin.Mode = ComboBoxBinarize.SelectedIndex
                m_video.Binarize = bin
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode : " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Trigger ModeR{{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' m[}[hEgK[hEOgK[h̑IB
    ''' </remarks>
    Private Sub ComboBoxTrigger_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxTrigger.SelectedIndexChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.Trigger = ComboBoxTrigger.SelectedIndex
                'ЃLv`{[h̓gK[[h̐ݒɃZbgAbv^CKvɂȂ܂
                '{vÕZbgAbv^C͕Kvőlł350msݒ肵Ă܂B
                'Lv`{[hɂĂ̎Ԃ͈قȂ܂B
                Threading.Thread.Sleep(350)
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Exposure NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' JIԂ̐ݒB
    ''' </remarks>
    Private Sub ExposureValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownExposure.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                m_video.ExposureTime = NumericUpDownExposure.Value
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Bin Threshold NumericUpDown
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 2l臒l̐ݒB
    ''' </remarks>
    Private Sub NumericUpDownThreshold_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NumericUpDownThreshold.ValueChanged
        Try
            If (m_flgVideoOpened = True) Then
                'CFviVideoBinarize\̂̃CX^X̃oʂɕύX鎖͏oȂׁAȉ̗lɂĐݒB
                Dim bin As FVIL.Video.CFviVideoBinarize = m_video.Binarize
                bin.Threshold = NumericUpDownThreshold.Value
                m_video.Binarize = bin
            End If
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode : " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' ReLoad Ini File{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' rfIݒpinit@C̍ĐݒB
    ''' </remarks>
    Private Sub ButtonReLoadIni_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReLoadIni.Click
        Try
            't[Ȃ΁A~B
            If (m_flgFreerun = True) Then
                't[~
                fnStopFreerun()
            End If
            '摜bNĂ
            If (m_video.ContinuousGrab.IsMemoryLocked) Then
                '摜bN̉
                m_video.ContinuousGrab.MemoryUnlock()
            End If

            'init@CI
            fnSetIniFile()
        Catch ex As Exception
            'G[
            intErr = m_video.ErrorCode
            MessageBox.Show("ErrorCode= " + intErr.ToString, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    ''' <summary>
    ''' Save Image{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' \摜ۑ
    ''' </remarks>
    Private Sub ButtonSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonSaveImage.Click
        Dim ofdlg As SaveFileDialog = New SaveFileDialog()
        ofdlg.Filter = "摜t@C(*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat)|*.bmp;*.dib;*.png;*.jpg;*.jpeg;*.tif;*.tiff;*.raw;*.pat"
        ofdlg.Filter += "|Bitmap t@C (*.bmp;*.dib)|*.bmp;*.dib"
        ofdlg.Filter += "|Png t@C (*.png)|*.png"
        ofdlg.Filter += "|Jpeg t@C (*.jpg;*.jpeg)|*.jpg;*.jpeg"
        ofdlg.Filter += "|Tiff t@C (*.tif;*.tiff)|*.tif;*.tiff"
        ofdlg.Filter += "|Raw t@C (*.raw)|*.raw"
        ofdlg.Filter += "|ׂẴt@C (*.*)|*.*"
        ofdlg.OverwritePrompt = True

        If (ofdlg.ShowDialog(Me) = Windows.Forms.DialogResult.OK) Then
            Try
                '̊֐́AȈՓIɉ摜t@C̕ۑŝׂ̂łB 
                '̊֐ŎwłȂp[^w肷Kv΁A e摜t@CANZXNX𒼐ڎgpĂB 
                FVIL.File.Function.SaveImageFile(ofdlg.FileName, CFviImageView1.Image)

                'ۑt@C`Œ̏ꍇ́Aȉ̂悤ɋLq܂B
                '1) bmpt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileBmp = New FVIL.File.CFviImageFileBmp()
                'file.Save(ofdlg.FileName, m_image)

                '2) jpgt@C̏ꍇ
                'Dim file As FVIL.File.CFviImageFileJpg = New FVIL.File.CFviImageFileJpg()
                'file.Save(ofdlg.FileName, m_image)

            Catch ex As FVIL.CFviException
                Dim msg As System.String = System.String.Format("CuO𔭍s܂Bcode={0} func={1}", ex.ErrorCode, ex.Function)
                Select Case (ex.ErrorCode)
                    Case FVIL.ErrorCode.NOT_SUPPORTED, _
                     FVIL.ErrorCode.INVALID_OBJECT
                        msg += vbCrLf + "T|[gĂȂ摜IuWFNgłB"
                        msg += vbCrLf + "Raw `ŕۑĂB"
                End Select
                MessageBox.Show(msg, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Catch ex As Exception
                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)

            End Try
        End If
    End Sub

    ''' <summary>
    ''' x1{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' {ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMag1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMag1.Click
        '摜̕\{̎擾܂͐ݒs܂B1.0Ǝw肷Ɠ{ŕ\܂B
        '{ĺA0.5Ƃꍇ́AE1/2ƂȂAʐς1/4ɂȂ܂B
        '3.0Ƃꍇ́AE3{ƂȂAʐς9{ɂȂ܂B
        CFviImageView1.Display.Magnification = 1.0      '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' Fit{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' 摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
    ''' </remarks>
    Private Sub ButtonFit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonFit.Click
        '摜Ŝr[̃NCAg̈ɕ\ł悤ɕ\{k(܂͊g)܂
        CFviImageView1.FitImageSize()                   '\{𒲐
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' {{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂B
    ''' </remarks>
    Private Sub ButtonPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonPlus.Click
        Dim Value As Double
        Value = CFviImageView1.Display.Magnification    '{̎擾
        Value = Value + 0.5
        CFviImageView1.Display.Magnification = Value    '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' |{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ݂̔{0.5{ŕ\܂BA{OȉɂȂꍇ͔{0.1ŕ\܂B
    ''' </remarks>
    Private Sub ButtonMinus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonMinus.Click
        Dim Value As Double
        Value = CFviImageView1.Display.Magnification    '{̎擾
        Value = Value - 0.5
        If (Value <= 0) Then
            Value = 0.1       'Oȉݒ肷ƃG[ɂȂ̂0.1ݒ肷
        End If
        CFviImageView1.Display.Magnification = Value    '\{̐ݒ
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' Ascope`FbN{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' ASCOPE̕\ؑւ܂B
    ''' </remarks>
    Private Sub CheckBoxAScope_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBoxAscope.CheckedChanged
        'ASCOPEI[oC̐ݒ
        If (CheckBoxAscope.CheckState) Then
            'ASCOPE̕\LɂB
            CFviImageView1.Display.OverlayAscope.Enable = True
            CFviImageView1.Display.OverlayAscope.Active = True
        Else
            'ASCOPE̕\𖳌ɂB
            CFviImageView1.Display.OverlayAscope.Enable = False
            CFviImageView1.Display.OverlayAscope.Active = False
        End If
        CFviImageView1.Refresh()                        'ĕ`

    End Sub

    ''' <summary>
    ''' Lv`[eLXg{bNX
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Lv`[̃NvB
    ''' </remarks>
    Private Sub TextBoxCaptureNumber_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxCaptureNumber.TextChanged
        Try
            If (TextBoxCaptureNumber.Text < 0) Then
                TextBoxCaptureNumber.Text = 0
            End If
        Catch ex As Exception
            'G[
            'ȊO̓͂10ɏB
            TextBoxCaptureNumber.Text = 10
        End Try
    End Sub

End Class
